      subroutine vvsmd(g,u1,u2,u3,mat)
c----------------------------------------------------------------------c
c Returns a matrix element array for the triple vector-scalar boson  
c coupling
c
c Input: u1,u2 - vectors,
c        u3 -sclar
c        g - a scalar-gauge-boson coupling.
c All four momenta are cosidered as incoming to the vertex.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 14 May, 2007; modified 
c----------------------------------------------------------------------c

      implicit none

      integer, parameter :: dp=kind(1.d0)
      complex(dp) :: g,u1(0:3),u2(0:3),u3,mat

      mat=g*u3*(u1(0)*u2(0)-u1(1)*u2(1)-u1(2)*u2(2)-u1(3)*u2(3))

      end subroutine vvsmd
