      subroutine chanopt(ndim)
c----------------------------------------------------------------------c
c Redefines integration weights in such a way that the same kinematical
c channels are not called
c
c Input: ndim - dimension of the phase space integral
c
c Karol Kolodziej, University of Silesia, karol.kolodziej@us.edu.pl
c 28 January, 2008, modiffied on 
c----------------------------------------------------------------------c
      use mathprms 
      use inprms
      use drivekk
      use partcls

      implicit none

      integer :: ndim,i

      real(dp) :: x(ndim),flux,dlinv,p(0:3,nepl),pall(0:3),dl(nkin)
      real :: y(ndim)

      do ikin=1,nkin
       if (aw(ikin) > 0.d0) then
        call kinin(ecm,m(1:2),p(:,1:2),flux)
        if ( irand == 1) then
         call random_number(y)
        else if ( irand == 2) then
         call ranlux(y,ndim)
        end if
        x=dble(y)
        call kincls(ikin,1,ecm,p,x,ndim,dlinv)
        if (dlinv > 0.d0) then 
c Test momentum conservation
         pall=0.d0
         do i=nisp+1,nepl
          pall=pall+p(:,i)
         end do

         if (abs(pall(1)) > 1.d-10) then
          write(7,*)'ikin=',ikin
          write(7,*)'pall1=',pall
         else if (abs(pall(2)) > 1.d-10) then
          write(7,*)'ikin=',ikin
          write(7,*)'pall2=',pall
         else if (abs(pall(3)) > 1.d-10) then
          write(7,*)'ikin=',ikin
          write(7,*)'pall3=',pall
         else if (abs(pall(0)-ecm) > 1.d-10) then
          write(7,*)'ikin=',ikin
          write(7,*)'pall0=',pall
         end if

         do i=nisp+1,nepl
          if (abs(m(i)-sqrt(abs(p(0,i)**2-p(1,i)**2-p(2,i)**2
     &                         -p(3,i)**2))) > 1.d5) then
           write(7,*)'ikin=',ikin
           write(7,*)'i=',i,m(i),
     &           sqrt(abs(p(0,i)**2-p(1,i)**2-p(2,i)**2-p(3,i)**2))
           write(7,*)'pall=',pall
          end if
         end do

         dl(:ikin)=0.d0

         call kincls(ikin,0,ecm,p,x,ndim,dl(ikin))

         do i=ikin-1,1,-1
c          call kincls(i,0,ecm,p,x,ndim,dl(i))
          if (aw(i) > 0.d0) then
           call kincls(i,0,ecm,p,x,ndim,dl(i))
c           if (dl(ikin) == dl(i)) then
           if (abs(dl(ikin)-dl(i)) < 1.d-14*dl(i)) then
            aw(i)=aw(i)+aw(ikin)
            aw(ikin)=0.d0
            dl(ikin)=0.d0
            exit
           end if
          end if
         end do
        end if
       end if
      end do

      end 
